package CH.ifa.draw.io.exportFormats;

import CH.ifa.draw.framework.Drawing;

import CH.ifa.draw.io.EPSFileFilter;

import CH.ifa.draw.util.ColorMap;
import CH.ifa.draw.util.PostscriptWriter;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.event.KeyEvent;

import java.io.File;
import java.io.FileOutputStream;


public class EPSExportFormat extends ExportFormatAbstract {
    // Attributes
    // Construktor
    public EPSExportFormat() {
        super("EPS", new EPSFileFilter());
    }

    // Methods


    /**
     * @see de.renew.io.ExportFormat#canExportNto1()
     */
    public boolean canExportNto1() {
        return false;
    }

    /**
     * @see de.renew.io.ExportFormat#export(CH.ifa.draw.framework.Drawing, java.net.URI)
     */
    public File export(Drawing drawing, File path) throws Exception {
        File result = null;
        if (drawing != null && path != null) {
            result = path;
            FileOutputStream stream = new FileOutputStream(result);
            PostscriptWriter ps = null;
            Dimension pageSize = new Dimension(535, 788);
            Rectangle drawingBox = drawing.getBounds();
            ps = new PostscriptWriter(stream, drawingBox);
            ps.setColorConversion(ColorMap.BACKGROUND, Color.white);
            drawing.draw(ps);

            // view().drawHandles(ps);
            ps.dispose();
        }
        assert (result != null) : "Failure in EPSExportFormat: result == null";
        return result;
    }

    /**
     * @see de.renew.io.ExportFormat#export(CH.ifa.draw.framework.Drawing[], java.net.URI)
     */
    public File export(Drawing[] drawings, File path) throws Exception {
        File result = null;
        assert (result != null) : "Failure in EPSExportFormat: result == null";
        return result;
    }

    public boolean canExportDrawing(Drawing drawing) {
        boolean result = false;
        result = true;
        return result;
    }

    public int getShortCut() {
        return KeyEvent.VK_E;
    }
}