/*
 * Created on 28.01.2004
 *
 */
package CH.ifa.draw.util;

import java.awt.Toolkit;

import javax.swing.JMenuItem;
import javax.swing.KeyStroke;


/**
 * This class represents a JMenuItem that knows a Command to be triggered
 * if the item is selected by the user.
 *
 * @author J&ouml;rn Schumacher
 */
public class CommandMenuItem extends JMenuItem {
    final Command cmd;

    public CommandMenuItem(Command cmd) {
        super(cmd.name());
        this.cmd = cmd;
    }

    public CommandMenuItem(Command cmd, int ms) {
        super(cmd.name());
        setAccelerator(KeyStroke.getKeyStroke(ms,
                                              Toolkit.getDefaultToolkit()
                                                     .getMenuShortcutKeyMask()));
        this.cmd = cmd;
    }
}