package de.renew.formalism.fs;

import collections.CircularList;
import collections.CollectionEnumeration;
import collections.UpdatableSeq;

import de.uni_hamburg.fs.TypeSystem;

import de.renew.formalism.java.ParsedDeclarationNode;

import java.util.NoSuchElementException;


public class ParsedFSDeclarationNode extends ParsedDeclarationNode {
    UpdatableSeq accesses = new CircularList();

    public ParsedFSDeclarationNode() {
    }

    public ParsedFSDeclarationNode(String defaultAccess) {
        super();
        accesses.insertFirst(defaultAccess);
    }

    public void addAccess(String decl, de.renew.formalism.java.Token token)
            throws de.renew.formalism.java.ParseException {
        accesses.insertFirst(decl);
        //System.out.println("Accessing Namespace "+decl+".");
    }

    public Object interpreteName(String name) {
        // A concept in an imported namespace?
        CollectionEnumeration namespaces = accesses.elements();
        while (namespaces.hasMoreElements()) {
            String nmspc = (String) namespaces.nextElement();
            try {
                return TypeSystem.instance().conceptForName(nmspc + "::" + name);
            } catch (NoSuchElementException e) {
            }
        }

        //System.out.println(this+" found no interpretation for concept "+name+" found, handing on to super.");
        return super.interpreteName(name);
    }
}