package de.renew.formalism.fs;

import de.renew.formalism.java.ArcFactory;
import de.renew.formalism.java.InscriptionParser;
import de.renew.formalism.java.ParsedDeclarationNode;
import de.renew.formalism.java.SingleJavaNetCompiler;

import de.renew.shadow.ShadowNet;
import de.renew.shadow.ShadowPreprocessor;
import de.renew.shadow.SyntaxException;

import java.util.Collection;


public class SingleFSNetCompiler extends SingleJavaNetCompiler {
    public SingleFSNetCompiler() {
        super(true, false, true);
    }

    public ShadowPreprocessor[] getRequiredPreprocessors() {
        return new ShadowPreprocessor[] { new FSNetPreprocessor() };
    }

    protected InscriptionParser makeParser(String inscr) {
        return new FSNetParser(new java.io.StringReader(inscr));
    }

    protected Collection parseArcInscription(String inscr)
            throws SyntaxException {
        if (inscr == null || inscr.equals("")) {
            inscr = "[]";
        }
        return super.parseArcInscription(inscr);
    }

    protected ParsedDeclarationNode makeEmptyDeclarationNode(ShadowNet net) {
        if (net != null) {
            return new ParsedFSDeclarationNode(net.getName());
        }
        return new ParsedFSDeclarationNode();
    }

    protected ArcFactory getArcFactory(int arcType, boolean allowTime) {
        return new FSArcFactory(arcType, allowTime);
    }
}