package de.renew.formalism;

import de.renew.plugin.PluginProperties;

import de.renew.shadow.ShadowCompilerFactory;

import java.util.HashMap;
import java.util.Iterator;


/**
 * @author 6schumac
 *
 * A class that keeps track of all available shadow compilers.
 * These compilers represent the different formalisms in which a net may be compiled.
 */
public class CompilerStore extends HashMap {
    CompilerStore() {
        super();
    }

    /**
     * Register a RenewMode under the specified name.
     */
    public void addCompilerFactory(String compilerName,
                                   ShadowCompilerFactory compilerFactory) {
        if (PluginProperties.debug()) {
            System.out.println("CompilerStore: compiler " + compilerName
                               + " registered.");
        }
        put(compilerName, compilerFactory);
    }


    /**
     *
     * @return an Iterator containing the (String) names of the registered Modes
     */
    Iterator getKnownFormalisms() {
        return keySet().iterator();
    }
}