package de.renew.formalism.function;

import de.renew.expression.Function;

import de.renew.unify.Impossible;
import de.renew.unify.Tuple;

import java.lang.reflect.InvocationTargetException;


public abstract class AbstractMethodFunction implements Function {
    public abstract Object doFunction(Object obj, Object[] paramArr)
            throws Exception;

    public Object function(Object param) throws Impossible {
        Tuple tuple = (Tuple) param;
        if (tuple.getArity() != 2) {
            throw new Impossible();
        }
        Object obj = tuple.getComponent(0);
        Tuple args = (Tuple) tuple.getComponent(1);

        Object[] paramArr = new Object[args.getArity()];
        for (int i = 0; i < paramArr.length; i++) {
            paramArr[i] = args.getComponent(i);
        }

        try {
            return doFunction(obj, paramArr);
        } catch (Exception e) {
            if (e instanceof InvocationTargetException) {
                Throwable targetException = ((InvocationTargetException) e)
                                            .getTargetException();
                if (MethodFunction.DEBUG_METHOD_CALLS) {
                    targetException.printStackTrace();
                    System.err.println("while executing " + this.toString());
                }
                throw new Impossible("Method call resulted in an exception: "
                                     + targetException, targetException);
            } else {
                if (MethodFunction.DEBUG_METHOD_CALLS) {
                    e.printStackTrace();
                    System.err.println("while executing " + this.toString());
                }
                throw new Impossible("Exception occured during method call: "
                                     + e, e);
            }
        }
    }
}