package de.renew.gui.maria;

import de.renew.net.Net;
import de.renew.net.NetLoader;

import de.renew.shadow.ShadowCompiler;
import de.renew.shadow.ShadowLookup;
import de.renew.shadow.ShadowNet;
import de.renew.shadow.ShadowPreprocessor;
import de.renew.shadow.SyntaxException;

import java.io.StringReader;


public class SingleMariaNetCompiler implements ShadowCompiler {
    public void setLoopbackNetLoader(NetLoader loopbackNetLoader) {
        // Not needed.		
    }

    public void setShadowLookup(ShadowLookup shadowLookup) {
        // Not needed.
    }

    public Net createNet(String name) {
        return new Net(name);
    }

    public ShadowPreprocessor[] getRequiredPreprocessors() {
        return new ShadowPreprocessor[0];
    }

    public void compile(ShadowNet shadowNet) throws SyntaxException {
        // No-op implementation. Maria nets are not simulated,
        // only exported.
    }

    public static MariaParser createParser(String inscr) {
        return new MariaParser(new StringReader(inscr));
    }

    public String checkDeclarationNode(String inscr, boolean special,
                                       ShadowNet shadowNet)
            throws SyntaxException {
        try {
            createParser(inscr).netinscr();
        } catch (ParseException e) {
            throw new SyntaxException(e.toString(), null);
        }
        return null;
    }

    public String checkArcInscription(String inscr, boolean special,
                                      ShadowNet shadowNet)
            throws SyntaxException {
        try {
            createParser(inscr).marking_list();
        } catch (ParseException e) {
            throw new SyntaxException(e.toString(), null);
        }
        return null;
    }

    public String checkTransitionInscription(String inscr, boolean special,
                                             ShadowNet shadowNet)
            throws SyntaxException {
        try {
            createParser(inscr).transinscr();
        } catch (ParseException e) {
            throw new SyntaxException(e.toString(), null);
        }
        return null;
    }

    public String checkPlaceInscription(String inscr, boolean special,
                                        ShadowNet shadowNet)
            throws SyntaxException {
        try {
            if (special) {
                createParser(inscr).typeorcapacity();
            } else {
                createParser(inscr).placeinscr();
            }
        } catch (ParseException e) {
            throw new SyntaxException(e.toString(), null);
        }
        return null;
    }
}