package de.renew.plugin.command;

import de.renew.plugin.PluginManager;


/**
 * Executing this command unloads all plugins and exits the Java VM.
 * If the argument "force" is given, the plugins are not shut down
 * previous to exiting.
 *
 * @author J&ouml;rn Schumacher
 */
public class ExitCommand implements CLCommand {
    /*
    * exit the plugin system
    */
    public void execute(String[] args) {
        if (args.length > 0) {
            if ("force".equals(args[0])) {
                System.exit(0);
            }
        }
        PluginManager.getInstance().stop();
    }

    public String getDescription() {
        return "leave plugin system";
    }
}