package de.renew.plugin.command;

import java.util.Iterator;
import java.util.Map;


/**
 * This command displays a list of commands that are registered
 * in the PluginManager, including their description.
 *
 * @author J&ouml;rn Schumacher
 */
public class HelpCommand implements CLCommand {
    private Map _commands;

    public HelpCommand(Map commands) {
        _commands = commands;
    }

    /*
    * print all available commands
    */
    public void execute(String[] args) {
        System.out.println("available commands:");
        Iterator keys = _commands.keySet().iterator();
        while (keys.hasNext()) {
            String key = (String) keys.next();
            CLCommand command = (CLCommand) _commands.get(key);
            System.out.println(key + "\t-\t" + command.getDescription());
        }
    }

    public String getDescription() {
        return "print a list of all commands";
    }
}