package de.renew.engine.searcher;



/**
 * I am the trace interface. My children will allow
 * the output of trace messages. There might be quite a few ways
 * of doing that, although printing strings to the console
 * seems to be the most natural.
 **/
public interface Tracer {

    /**
     * Process a trace message.
     *
     * @param message
     *   the message to be output
     **/
    public void trace(String message);

    /**
     * This tells me that all trace messages have arrived.
     * My descendents will perform an appropriate action, if any.
     **/
    public void complete();
}