package de.renew.net.arc;

import de.renew.engine.searcher.Occurrence;
import de.renew.engine.searcher.OccurrenceDescription;
import de.renew.engine.searcher.Searcher;
import de.renew.engine.searcher.VariableMapperCopier;

import de.renew.expression.VariableMapper;

import de.renew.net.NetInstance;
import de.renew.net.PlaceInstance;

import de.renew.unify.Impossible;
import de.renew.unify.Variable;

import java.util.Collection;
import java.util.Collections;


class ClearArcOccurrence implements Occurrence {
    PlaceInstance placeInstance;
    VariableMapper mapper;
    Variable variable;
    ClearArc arc;

    ClearArcOccurrence(ClearArc arc, VariableMapper mapper,
                       NetInstance netInstance) {
        this.arc = arc;
        this.mapper = mapper;
        placeInstance = netInstance.getInstance(arc.place);
    }

    public Collection makeBinders(Searcher searcher) throws Impossible {
        variable = new Variable(arc.expression.startEvaluation(mapper,
                                                               searcher.recorder,
                                                               searcher.calcChecker),
                                searcher.recorder);

        searcher.calcChecker.addCalculated(arc.expression.getType(), variable,
                                           null, searcher.recorder);
        return Collections.EMPTY_SET;
    }

    public Collection makeExecutables(VariableMapperCopier variableMapperCopier) {
        Variable copiedVariable = (Variable) variableMapperCopier.getCopier()
                                                                 .copy(variable);

        return Collections.singleton(new ClearArcExecutable(placeInstance,
                                                            copiedVariable, arc));
    }

    public OccurrenceDescription makeOccurrenceDescription(VariableMapperCopier variableMapperCopier) {
        return null;
    }
}