package de.renew.net.arc;

import de.renew.engine.searcher.LateExecutable;
import de.renew.engine.searcher.Tracer;
import de.renew.engine.searchqueue.SearchQueue;

import de.renew.net.PlaceInstance;

import de.renew.unify.Variable;

import de.renew.util.Value;


class OutputArcExecutable implements LateExecutable {
    PlaceInstance placeInstance;
    Variable tokenVar;
    Variable timeVar;
    boolean trace;

    OutputArcExecutable(PlaceInstance placeInstance, Variable tokenVar,
                        Variable timeVar, boolean trace) {
        this.placeInstance = placeInstance;
        this.tokenVar = tokenVar;
        this.timeVar = timeVar;
        this.trace = trace;
    }

    public int phase() {
        return OUTPUT;
    }

    // We can put a token into an output place quickly.
    public boolean isLong() {
        return false;
    }

    public void execute(Tracer tracer) {
        double time = SearchQueue.getTime();
        if (timeVar != null) {
            time += ((Value) timeVar.getValue()).doubleValue();
        }

        if (trace) {
            tracer.trace("    Putting " + tokenVar.getValue() + " into "
                         + placeInstance + " at " + time);
        }
        placeInstance.insertToken(tokenVar.getValue(), time);
    }

    public void executeAfterException(Tracer tracer, Throwable t) {
        // Do not output any ordinary tokens.
        // The tokens might not even be available.
    }
}