package de.renew.net.inscription;

import de.renew.engine.common.RangeEnumeratorOccurrence;
import de.renew.engine.searcher.Searcher;

import de.renew.expression.Expression;
import de.renew.expression.VariableMapper;

import de.renew.net.NetInstance;
import de.renew.net.TransitionInscription;

import de.renew.unify.Impossible;

import java.util.Collections;


public class RangeEnumeratorInscription implements TransitionInscription {
    private Expression expr;
    private boolean checkBound;
    private int first;
    private int last;

    public RangeEnumeratorInscription(Expression expr, int first, int last,
                                      boolean checkBound) {
        this.expr = expr;
        this.first = first;
        this.last = last;
        this.checkBound = checkBound;
    }

    public java.util.Collection makeOccurrences(VariableMapper mapper,
                                                NetInstance netInstance,
                                                Searcher searcher)
            throws Impossible {
        return Collections.singleton(new RangeEnumeratorOccurrence(expr,
                                                                   checkBound,
                                                                   mapper,
                                                                   first, last));
    }
}