package de.renew.shadow;

import java.util.Vector;


public class SyntaxException extends Exception {
    public final String[] detailed;
    public final int line;
    public final int column;
    public final Vector errorObjects;

    public SyntaxException(String msg, String[] detailed, int line, int column) {
        super(msg);
        this.detailed = detailed;
        this.line = line;
        this.column = column;
        errorObjects = new Vector();
    }

    public SyntaxException(String msg, String[] detailed) {
        super(msg);
        this.detailed = detailed;
        this.column = 0;
        this.line = 0;
        errorObjects = new Vector();
    }

    public SyntaxException addObject(Object graphicObject) {
        errorObjects.addElement(graphicObject);
        return this;
    }
}